<template>
  <v-card>
    <v-card-title>
      Detalle del Cliente
      <v-spacer />
      {{ cliente.idclientes }}
    </v-card-title>
    <v-card-text :class="$vuetify.breakpoint.smAndDown ? 'dialog-content-scrollerd-smartphone' : 'dialog-content-scrollerd'">
      <up-list-key-values class="elevation-2" :data="atributosCliente" />
      <lista-ventas :detallecliente="true" :clientedetalle="cliente" />
      <lista-mascotas :detalle-cliente="true" :cliente-actual="cliente" @onEdit="editarForm" />
      <lista-historias-clinicas :detalle-cliente="true" :cliente-actual="cliente" @onEdit="editarFormHistoriaClinica" />
    </v-card-text>
    <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
      <v-btn class="elevation-2 font-weight-light" @click="cerrarDialog()">
        Cerrar
      </v-btn>
    </v-card-actions>
    <v-dialog v-model="dialogMascota" width="800" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-mascotas v-if="dialogMascota" :cliente-actual="cliente" :mascota="mascotaActual" @onClose="closeDialog" />
    </v-dialog>
    <v-dialog v-model="dialogHistoriasClinicas" width="1000" :fullscreen="$vuetify.breakpoint.smAndDown">
      <form-historias-clinicas v-if="dialogHistoriasClinicas" :historiaclinica="historiaClinica" @onClose="closeDialogHistoriaClinica"></form-historias-clinicas>
    </v-dialog>
    <up-web-view v-if="showDialogPDF" :url="urlPDF" @onClose="showDialogPDF=false" />
  </v-card>
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'vue-property-decorator'
import { Cliente } from '~/core/models/cliente'
import UpListKeyValues from '~/components/shared/UpListKeyValues.vue'
import { AppStore } from '~/store/AppStore'
import ListaVentas from '~/components/ventas/listaVentas.vue'
import { App } from '~/core/App'
import AppToast from '~/core/utils/AppToast'
import UpWebView from '~/components/shared/UpWebView.vue'
import { Mascota } from '~/core/models/mascota'
import ListaMascotas from '~/components/mascotas/listaMascotas.vue'
import ListaHistoriasClinicas from '~/components/historiasClinicas/listaHistoriasClinicas.vue'
import FormMascotas from '~/components/mascotas/formMascotas.vue'
import { HistoriaClinica } from '~/core/models/historiaClinica'
import FormHistoriasClinicas from "~/components/historiasClinicas/formHistoriasClinicas.vue";
    @Component({
      components: {FormHistoriasClinicas, FormMascotas, ListaHistoriasClinicas, ListaMascotas, UpWebView, ListaVentas, UpListKeyValues }
    })
export default class detalleCliente extends Vue {
        @Prop() cliente!:Cliente;

        dialogMascota:boolean = false;
        mascotaActual:Mascota = null;
        dialogHistoriasClinicas:boolean = false;
        historiaClinica:HistoriaClinica = null;

        showDialogPDF:boolean = false;
        urlPDF:string = '';

        get atributosCliente () {
          return this.cliente
            ? [
                ['Nombre', this.cliente.nombre],
                ['DNI', this.cliente.dni],
                ['Dirección', this.cliente.direccion],
                ['Teléfono', this.cliente.telefono],
                ['E-mail', this.cliente.email]
              ]
            : []
        }

        editarForm (val) {
          this.mascotaActual = val
          this.dialogMascota = true
        }

        editarFormHistoriaClinica (val) {
          this.historiaClinica = val
          this.dialogHistoriasClinicas = true
        }

        closeDialogHistoriaClinica () {
          this.dialogHistoriasClinicas = false
          this.historiaClinica = null
        }

        closeDialog () {
          this.dialogMascota = false
          this.mascotaActual = null
        }

        imprimirReporte () {
          const f = {
            cliente: this.cliente.idclientes
          }

          AppStore.SHOW_LOADING('Descargando datos...')

          const url = `${AppStore.API_URL}comprobantes/historial`
          App.$axios.get(url, {
            headers: { Accept: 'application/json' },
            params: f,
            responseType: 'blob'
          }).then((res) => {
            const data:Blob = res.data

            this.urlPDF = window.URL.createObjectURL(data)
            this.showDialogPDF = true
          }).catch(() => {
            AppToast.error('Hubo un error al descargar los datos para imprimir')
          }).finally(() => {
            AppStore.HIDE_LOADING()
          })

          // App.openNewWindow(url, 'Listado de Reclamos',{centerscreen: true});
        }

        cerrarDialog () {
          this.$emit('onClose')
        }
}
</script>

<style lang="scss">

</style>
